      
Device = 16F676   '  

Config WDT_off, pwrte_on, mclre_off, intrc_osc_noclkout

Xtal = 4   '    4 

'--------------------------   ------------------------------------
Declare  Adin_Res 10   '    
Declare  Adin_Tad FRC   '   
Declare  Adin_Stime 50   '       
'--------------------------   ---------------------------
'-------------------------- OPTION_REG ----------------------------------------
                                                                   
Symbol PS0 = OPTION_REG.0      '    TMR0
Symbol PS1 = OPTION_REG.1      '    TMR0
Symbol PS2 = OPTION_REG.2      '    TMR0
Symbol PSA = OPTION_REG.3      '   
Symbol T0SE = OPTION_REG.4     '    TMR0    
Symbol T0CS = OPTION_REG.5     '     TMR0 
Symbol INTEDG = OPTION_REG.6   '         INT
Symbol NOT_RBPU = OPTION_REG.7 '     PORTB
                                                                   
'-------------------------- INTCON --------------------------------------------
                                                                   
Symbol RBIF = INTCON.0 '     PORTB.4-PORTB.7
Symbol INTF = INTCON.1 '     PORTB.0(INT)
Symbol T0IF = INTCON.2 '   TMR0
Symbol RBIE = INTCON.3 '     PORTB.4-PORTB.7
Symbol INTE = INTCON.4 '     PORTB.0(INT) 
Symbol T0IE = INTCON.5 '      TMR0
Symbol PEIE = INTCON.6 '      
Symbol GIE = INTCON.7  '    

ADCON0 = %10000000
ADCON1 = %00110000
ANSEL  = %00000001
CMCON  = %00000111

TRISA = %00000001
TRISC = %00000001

Dim BAT       As Float          '  
Dim VA        As Float          ' 
Dim BIG       As  Dword         '    
Dim BIG1      As  BIG.HighWord  '
Dim Sec       As  Byte          '
Dim   Minute  As  Byte          '
Dim   Hour    As  Byte          '             
Symbol St        = PORTC.0      '   
Symbol CHARGE    = PORTC.1      '    
Symbol DISCHARGE = PORTC.2      '   
Symbol SVEND     = PORTC.3      '  

'--------------------------  TMR0   --------------------
OPTION_REG = %10000111
TMR0 = $00            '   TMR0
T0IE = 1              '     TMR0   3906,250000                                                                   
GIE = 1               '   
                                                                   
On_Interrupt GoTo  Int_Label

'--------------------------  -------------------------
Start: 
BAT = ADIn 0                                                 '  0-    BAT 
VA = BAT / 204.8                                             '   5                                                             
Sec = 0                                                      '                                
If VA > 1.2 And St = 0 Then GoTo ROZRYAD : Else : GoTo Start '
GoTo Start                                                   '
End                                                          '

'-------------------------- --------------------------

Int_Label:
Context Save                                        '    
If T0IF = 1 Then  BIG1  = BIG1 - 1                  '   TMR0,        BIG1 ,   ,    65536  BIG ,    
If BIG < 0 Then BIG = BIG + 1000000 : Inc Sec       '  BIG < 0     ,      1000000 
T0IF = 0                                            '    
Context Restore                                     '                                                                         
End

'--------------------------   -------------------------
PREDZARYAD:                               '  
 
BAT = ADIn 0                              '  0-    BAT 
VA = BAT / 204.8                          '   5  
If VA < 1.2 Then GoTo  Start
If VA < 2.0 Then High CHARGE : DelayMS 2000 : Low CHARGE : DelayMS 2000 '
If VA > 2.0 Then GoTo ZARYAD

GoTo PREDZARYAD
End                                         '
 
ZARYAD:
 
BAT = ADIn 0                                     '  0-    BAT 
VA = BAT / 204.8                                 '   5 
If VA < 1.2 Then GoTo  Start                     '
If VA < 2.0 Then GoTo  PREDZARYAD                '
If VA > 2.0 Then High CHARGE : Else : Low CHARGE '
If VA > 3.0 Then Low CHARGE  : GoTo Start        '

If Sec = 60 Then Sec = 0 : Inc Minute            '   60  ,     ,   
If Minute = 60 Then Minute = 0 : Inc Hour        '  60  ,    0 ,   
If  Hour = 9 Then GoTo CHARGEEND                 '
GoTo ZARYAD                                      '
End                                              '

ROZRYAD:

BAT = ADIn 0                                 '  0-    BAT 
VA = BAT / 204.8                             '   5 
If VA < 2.05 Then Low DISCHARGE : GoTo ZARYAD'
If VA > 2.2 Then High DISCHARGE              '
'If  St = 0 Then GoTo Start                  '     
If VA < 1.2 Then GoTo  Start                 '
GoTo ROZRYAD                                 '
End

CHARGEEND:

BAT = ADIn 0                  '  0-    BAT 
VA = BAT / 204.8              '   5 
If VA < 1.2 Then GoTo  Start  '                   '
                              '
Low CHARGE                    '
Low DISCHARGE                 '
SVEND = 1                     '
Sec = 0                       '
Minute = 0                    '
Hour = 0                      '

GoTo CHARGEEND                '
End




